<template lang="pug">
  div(v-if='editDocument')
    edit-doc(:meeting-id='meetingId' :user-id="userId" :document-id='documentId' :firebase='firebase' :functions='functions' v-on:finish-edit-doc='editDocument=false; documentId=null')
  div(v-else)
    manage-docs(:meeting-id='meetingId' :user-id="userId" :firebase='firebase' :functions='functions' :configuration-mode="configurationMode" v-on:set-document-id='documentId=$event; editDocument=true')
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import VueCookies from "vue-cookies";
import * as firebase from "firebase/app";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";

import ManageDocs from "./ManageDocs.vue";
import EditDoc from "./EditDoc.vue";

Vue.use(VueCookies);

export default Vue.extend({
  name: "GDocsPlugin",
  props: {
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    functions: {
      required: true,
      type: Object as PropType<firebase.functions.Functions>,
    },
    meetingId: {
      required: true,
      type: String,
    },
    userId: {
      required: true,
      type: String,
    },
    configurationMode: {
      type: Boolean,
    },
  },
  components: {
    ManageDocs,
    EditDoc
  },
  data() {
    return {
      editDocument: false,
      documentId: null as null | string
    };
  },
  mounted() {
    const parameters = new URLSearchParams(window.location.search);
    if (parameters.get("auth") === "success") {
      // Since we do oAuth in a separate window, close it when we're done.
      window.close();
    }
  }
});
</script>
